<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "patientemail".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Patientemail".
 *
 * Columns in table "patientemail" available as properties of the model,
 * followed by relations of table "patientemail" available as properties of the model.
 *
 * @property integer $id
 * @property integer $opt_out
 * @property integer $account_id
 * @property integer $practice_id
 * @property integer $account_device_id
 * @property integer $auto_rr_sent_count
 * @property string $auto_rr_send_link
 * @property string $rr_guid
 * @property string $auto_rr_send_link_detail
 * @property string $patient_email
 * @property string $date_added
 * @property string $date_updated
 * @property string $patient_first_name
 * @property string $patient_middle_name
 * @property string $patient_last_name
 * @property integer $patientemail_batch_id
 * @property integer $clicked
 *
 * @property Account $account
 * @property Practice $practice
 * @property AccountDevice $accountDevice
 * @property PatientemailBatch $patientemailBatch
 * @property PatientemailCommunications[] $patientemailCommunications
 */
abstract class BasePatientemail extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'patientemail';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Patientemail|Patientemails', $n);
    }

    public static function representingColumn()
    {
        return 'patient_email';
    }

    public function rules()
    {
        return array(
            array('account_id, practice_id, patient_email, date_added, date_updated', 'required'),
            array('opt_out, account_id, practice_id, account_device_id, auto_rr_sent_count, patientemail_batch_id, clicked', 'numerical', 'integerOnly'=>true),
            array('auto_rr_send_link', 'length', 'max'=>7),
            array('rr_guid', 'length', 'max'=>40),
            array('auto_rr_send_link_detail', 'length', 'max'=>255),
            array('patient_email', 'length', 'max'=>254),
            array('patient_first_name, patient_middle_name', 'length', 'max'=>50),
            array('patient_last_name', 'length', 'max'=>80),
            array('opt_out, account_device_id, auto_rr_sent_count, auto_rr_send_link, rr_guid, auto_rr_send_link_detail, patient_first_name, patient_middle_name, patient_last_name, patientemail_batch_id, clicked', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, opt_out, account_id, practice_id, account_device_id, auto_rr_sent_count, auto_rr_send_link, rr_guid, auto_rr_send_link_detail, patient_email, date_added, date_updated, patient_first_name, patient_middle_name, patient_last_name, patientemail_batch_id, clicked', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'accountDevice' => array(self::BELONGS_TO, 'AccountDevice', 'account_device_id'),
            'patientemailBatch' => array(self::BELONGS_TO, 'PatientemailBatch', 'patientemail_batch_id'),
            'patientemailCommunications' => array(self::HAS_MANY, 'PatientemailCommunications', 'patientemail_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'opt_out' => Yii::t('app', 'Opt Out'),
            'account_id' => null,
            'practice_id' => null,
            'account_device_id' => null,
            'auto_rr_sent_count' => Yii::t('app', 'Auto Rr Sent Count'),
            'auto_rr_send_link' => Yii::t('app', 'Auto Rr Send Link'),
            'rr_guid' => Yii::t('app', 'Rr Guid'),
            'auto_rr_send_link_detail' => Yii::t('app', 'Auto Rr Send Link Detail'),
            'patient_email' => Yii::t('app', 'Patient Email'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'patient_first_name' => Yii::t('app', 'Patient First Name'),
            'patient_middle_name' => Yii::t('app', 'Patient Middle Name'),
            'patient_last_name' => Yii::t('app', 'Patient Last Name'),
            'patientemail_batch_id' => null,
            'clicked' => Yii::t('app', 'Clicked'),
            'account' => null,
            'practice' => null,
            'accountDevice' => null,
            'patientemailBatch' => null,
            'patientemailCommunications' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('opt_out', $this->opt_out);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('account_device_id', $this->account_device_id);
        $criteria->compare('auto_rr_sent_count', $this->auto_rr_sent_count);
        $criteria->compare('auto_rr_send_link', $this->auto_rr_send_link, true);
        $criteria->compare('rr_guid', $this->rr_guid, true);
        $criteria->compare('auto_rr_send_link_detail', $this->auto_rr_send_link_detail, true);
        $criteria->compare('patient_email', $this->patient_email, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('patient_first_name', $this->patient_first_name, true);
        $criteria->compare('patient_middle_name', $this->patient_middle_name, true);
        $criteria->compare('patient_last_name', $this->patient_last_name, true);
        $criteria->compare('patientemail_batch_id', $this->patientemail_batch_id);
        $criteria->compare('clicked', $this->clicked);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
